using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.SessionState;

namespace CustomModules
{
	public class Global : System.Web.HttpApplication
	{

		Dynamicweb.Admin.Global GlobalAsax = new Dynamicweb.Admin.Global();
		public void Application_Start(object sender, EventArgs e)
		{
			// Fires when the application is started
			GlobalAsax.Application_Start(sender, e);
			
            // Below outcommented by msn@dynamicweb.dk, 08-April-2010
            //Dynamicweb.ScheduledTask.Thread.Start();
		}

		public void Session_Start(object sender, EventArgs e)
		{
			// Fires when the session is started
			GlobalAsax.Session_Start(sender, e);
		}

		public void Application_BeginRequest(object sender, EventArgs e)
		{
			// Fires at the beginning of each request
			//GlobalAsax.Application_BeginRequest(sender, e);
		}

		public void Application_AuthenticateRequest(object sender, EventArgs e)
		{
			// Fires upon attempting to authenticate the use
			GlobalAsax.Application_AuthenticateRequest(sender, e);
		}

		public void Application_Error(object sender, EventArgs e)
		{
			// Fires when an error occurs
			GlobalAsax.Application_Error(sender, e);
		}

		public void Session_End(object sender, EventArgs e)
		{
			// Fires when the session ends
			GlobalAsax.Session_End(sender, e);
		}

		public void Application_End(object sender, EventArgs e)
		{
			// Fires when the application ends
			GlobalAsax.Application_End(sender, e);
		}

		public void Application_OnPreRequestHandlerExecute(object sender, EventArgs e)
		{
			GlobalAsax.Application_OnPreRequestHandlerExecute(sender, e);
		}
	}
}